{
    "$graph": [
        {
            "label": "gpx_make_outputs",
            "class": "CommandLineTool",
            "baseCommand": "gpx_make_outputs",
            "inputs": [
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-input-path"
                    },
                    "id": "#gpx_make_outputs.cwl/input_path"
                },
                {
                    "doc": "this parameter is fixed for this command line workflow, because the output is defined as single file\n",
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "prefix": "-num-partitions"
                    },
                    "id": "#gpx_make_outputs.cwl/num_partitions"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-output"
                    },
                    "id": "#gpx_make_outputs.cwl/output"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#gpx_make_outputs.cwl/output_glob"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "*",
                    "inputBinding": {
                        "prefix": "-unzip"
                    },
                    "id": "#gpx_make_outputs.cwl/unzip"
                }
            ],
            "id": "#gpx_make_outputs.cwl",
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_glob)"
                    },
                    "id": "#gpx_make_outputs.cwl/output_file"
                }
            ]
        },
        {
            "label": "kmer_compare_wnode",
            "class": "CommandLineTool",
            "baseCommand": "kmer_compare_wnode",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "submit_kmer_compare.kmer-files.mft",
                            "entry": "$(inputs.kmer_list.path)"
                        },
                        {
                            "entryname": "submit_kmer_compare.ref-kmer-files.mft",
                            "entry": "${var blob = '# submit_kmer_compare.ref-kmer-files.mft created for kmer_compare_wnode from input ref_kmer_list File\\n';  if(inputs.ref_kmer_list == null ) { return blob; } else { return blob +  inputs.ref_kmer_list.path + '\\n'; } }"
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "default": "outdir",
                    "inputBinding": {
                        "prefix": "-O"
                    },
                    "id": "#kmer_compare_wnode.cwl/O"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-dist-method"
                    },
                    "id": "#kmer_compare_wnode.cwl/dist_method"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-input-jobs"
                    },
                    "id": "#kmer_compare_wnode.cwl/jobs"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-kmer-cache-uri"
                    },
                    "id": "#kmer_compare_wnode.cwl/kmer_cache_sqlite"
                },
                {
                    "type": "File",
                    "id": "#kmer_compare_wnode.cwl/kmer_list"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "submit_kmer_compare.kmer-files.mft",
                    "inputBinding": {
                        "prefix": "-kmer-files-manifest"
                    },
                    "id": "#kmer_compare_wnode.cwl/kmer_manifest"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "submit_kmer_compare.ref-kmer-files.mft",
                    "inputBinding": {
                        "prefix": "-ref-kmer-files-manifest"
                    },
                    "id": "#kmer_compare_wnode.cwl/kmer_ref_manifest"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-minhash-signature"
                    },
                    "id": "#kmer_compare_wnode.cwl/minhash_signature"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#kmer_compare_wnode.cwl/ref_kmer_list"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-score-method"
                    },
                    "id": "#kmer_compare_wnode.cwl/score_method"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "$(inputs.O)"
                    },
                    "id": "#kmer_compare_wnode.cwl/outdir"
                }
            ],
            "id": "#kmer_compare_wnode.cwl"
        },
        {
            "label": "submit_kmer_compare",
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "submit_kmer_compare.kmer-files.mft",
                            "entry": "${return '# submit_kmer_compare.kmer-files.mft created for submit_kmer_compare from input kmer_list File\\n' + inputs.kmer_list.path + '\\n'; }"
                        },
                        {
                            "entryname": "submit_kmer_compare.ref-kmer-files.mft",
                            "entry": "${var blob =  '# submit_kmer_compare.ref-kmer-files.mft created for submit_kmer_compare from input ref_kmer_list File\\n'; if ( inputs.ref_kmer_list == null) { return blob; } else { return blob + inputs.ref_kmer_list.path + '\\n'; }}"
                        }
                    ]
                }
            ],
            "baseCommand": "submit_kmer_compare",
            "inputs": [
                {
                    "type": "File",
                    "id": "#submit_kmer_compare.cwl/kmer_list"
                },
                {
                    "type": "string",
                    "default": "submit_kmer_compare.kmer-files.mft",
                    "inputBinding": {
                        "prefix": "-kmer-files-manifest"
                    },
                    "id": "#submit_kmer_compare.cwl/kmer_list_impl"
                },
                {
                    "type": "string",
                    "default": "jobs.xml",
                    "inputBinding": {
                        "prefix": "-output"
                    },
                    "id": "#submit_kmer_compare.cwl/o"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#submit_kmer_compare.cwl/ref_kmer_list"
                },
                {
                    "type": "string",
                    "default": "submit_kmer_compare.ref-kmer-files.mft",
                    "inputBinding": {
                        "prefix": "-ref-kmer-files-manifest"
                    },
                    "id": "#submit_kmer_compare.cwl/ref_kmer_list_impl"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.o)"
                    },
                    "id": "#submit_kmer_compare.cwl/output"
                }
            ],
            "id": "#submit_kmer_compare.cwl"
        },
        {
            "label": "kmer_ref_compare_wnode",
            "class": "Workflow",
            "inputs": [
                {
                    "type": "string",
                    "id": "#main/dist_method"
                },
                {
                    "type": "File",
                    "id": "#main/kmer_cache_sqlite"
                },
                {
                    "type": "File",
                    "id": "#main/kmer_list"
                },
                {
                    "type": "string",
                    "id": "#main/minhash_signature"
                },
                {
                    "type": "File",
                    "id": "#main/ref_kmer_list"
                },
                {
                    "type": "string",
                    "id": "#main/score_method"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/gpx_make_outputs/output_file",
                    "id": "#main/distances"
                },
                {
                    "doc": "we hope to use this to pass instead of file list",
                    "type": "Directory",
                    "outputSource": "#main/kmer_compare_wnode/outdir",
                    "id": "#main/outdir"
                }
            ],
            "steps": [
                {
                    "run": "#gpx_make_outputs.cwl",
                    "in": [
                        {
                            "source": "#main/kmer_compare_wnode/outdir",
                            "id": "#main/gpx_make_outputs/input_path"
                        },
                        {
                            "default": 1,
                            "id": "#main/gpx_make_outputs/num_partitions"
                        },
                        {
                            "default": "distances.##.gz",
                            "id": "#main/gpx_make_outputs/output"
                        },
                        {
                            "default": "distances.*.gz",
                            "id": "#main/gpx_make_outputs/output_glob"
                        },
                        {
                            "default": "dont-unzip",
                            "id": "#main/gpx_make_outputs/unzip"
                        }
                    ],
                    "out": [
                        "#main/gpx_make_outputs/output_file"
                    ],
                    "id": "#main/gpx_make_outputs"
                },
                {
                    "run": "#kmer_compare_wnode.cwl",
                    "in": [
                        {
                            "source": "#main/dist_method",
                            "id": "#main/kmer_compare_wnode/dist_method"
                        },
                        {
                            "source": "#main/submit_kmer_compare/output",
                            "id": "#main/kmer_compare_wnode/jobs"
                        },
                        {
                            "source": "#main/kmer_cache_sqlite",
                            "id": "#main/kmer_compare_wnode/kmer_cache_sqlite"
                        },
                        {
                            "source": "#main/kmer_list",
                            "id": "#main/kmer_compare_wnode/kmer_list"
                        },
                        {
                            "source": "#main/minhash_signature",
                            "id": "#main/kmer_compare_wnode/minhash_signature"
                        },
                        {
                            "source": "#main/ref_kmer_list",
                            "id": "#main/kmer_compare_wnode/ref_kmer_list"
                        },
                        {
                            "source": "#main/score_method",
                            "id": "#main/kmer_compare_wnode/score_method"
                        }
                    ],
                    "out": [
                        "#main/kmer_compare_wnode/outdir"
                    ],
                    "id": "#main/kmer_compare_wnode"
                },
                {
                    "run": "#submit_kmer_compare.cwl",
                    "in": [
                        {
                            "source": "#main/kmer_list",
                            "id": "#main/submit_kmer_compare/kmer_list"
                        },
                        {
                            "source": "#main/ref_kmer_list",
                            "id": "#main/submit_kmer_compare/ref_kmer_list"
                        }
                    ],
                    "out": [
                        "#main/submit_kmer_compare/output"
                    ],
                    "id": "#main/submit_kmer_compare"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
